{
  Crystal Design Component.

  Global string "resources".

  Note! This data used to be in *.RC file. However, use of standard
  Delphi unit makes it easier to change and update texts.

  Copyright (c) 1996, SupraSoft Oy.

  Created: 10.2.1998.
  Changed:

}
unit Crystres;

interface

const
	ERR_None				      = 0;
	ERR_Unknown 		      = 1;
	ERR_EngineError	      = 2;
	ERR_UnknownExport       = 3;
	ERR_InvalidReportName   = 4;
	ERR_Logon			      = 5;
	ERR_Logoff			      = 6;
	ERR_BadFormulaName      = 7;

  RES_NoError            = '';
  RES_UnknownError       = 'Unknown error';
  RES_EngineError        = 'Failed to open a report engine';
  RES_UnknownExportError = 'Unknown type of export destination (ExportDestination)';
  RES_InvalidReportNameError = 'Invalid report name (ReportName)';
  RES_LogonError          = 'Failed to logon';
  RES_LogoffError         = 'Failed to logoff';
  RES_BadFormulaNameError = 'Bad or unknown formula name';

  RES_DLLNotFoundError = 'Crystal Report DLL library %s not found. Report features disabled.';

{$IFDEF WIN32}
  RES_CRPE_DLL         = 'CRPE32.DLL';
{$ELSE}
  RES_CRPE_DLL         = 'CRPE.DLL';
{$ENDIF}

  RES_ResetContent     = '%s reseted back to initial state';
  RES_SelectTable      = 'Please select a table and set user-ID and password';

  TXT_OK                 = 'OK';

function LoadErrorText(errorID: longint): string;

implementation

uses SysUtils;

const
  g_ErrorTextTable: array[0..7] of PChar = (
     RES_NoError,
     RES_UnknownError,
     RES_EngineError,
     RES_UnknownExportError,
     RES_InvalidReportNameError,
     RES_LogonError,
     RES_LogoffError,
     RES_BadFormulaNameError
  );


function LoadErrorText(errorID: longint): string;
begin
  if errorID < 0 then
     errorID := ERR_Unknown
  else if errorID >= (sizeof(g_ErrorTextTable) div sizeof(PChar)) then
     errorID := ERR_Unknown;
  Result := StrPas(g_ErrorTextTable[errorID]);
end;

end.
