{
  Crystal Design Component Demo Application 3:

  Copyright (c) 1997, SupraSoft Ltd

  Purpose of this program is to demonstrate
  - How to use Delphi's TQuery, TTable and TStoredProc components
    as a datasource in a report.
  - How to force dataset field types to a different type using
    SetDatasetFieldType-method.

  In this program you can enter standard SQL-query to a Memo1-component.
  The result of Query1-component is shown in a DBGrid and in a report.

}
unit Demo3;

interface

uses
  SysUtils, Classes, Controls,
  Forms, DBTables, DB, Grids, DBGrids, StdCtrls,
  Crystdsg;

type
  TForm1 = class(TForm)
    DBGrid1: TDBGrid;
    CrystalDesign1: TCrystalDesign;
    DataSource1: TDataSource;
    Database1: TDatabase;
    Query1: TQuery;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     procedure ActivateComponent;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  exePath: string;
begin
  exePath := ExtractFilePath(Application.ExeName);
  CrystalDesign1.ReportLocation := exePath;

  Memo1.Lines.Assign(Query1.SQL);

  { If database connection fails then please check the Params     }
  { property of Database1-component that it contains a valid path }
  { to the CUSTOMER.DBF file.                                     }
  Database1.Connected := FALSE;
  Database1.Params.Values['PATH'] := exePath;
  Database1.Connected := TRUE;
end;

procedure TForm1.ActivateComponent;
begin
  CrystalDesign1.Active := FALSE;

  { The first table (index 0) uses Query1 as a datasource }
  CrystalDesign1.SetNthDataset(0, Query1);

  { When we use string type in a DATE field, TField.DisplayFormat }
  { setting will be used also. If you comment out the             }
  { SetDatasetFieldType line then you'll see the difference.      }
  if Query1.FindField('ContactDat') <> nil then begin
     (Query1.FieldByName('ContactDat') as TDateField).DisplayFormat := '[mmm dd yyyy]';

     CrystalDesign1.SetDatasetFieldType (0, 'ContactDat', ftString);
  end;

  CrystalDesign1.Active := TRUE;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  CrystalDesign1.NextPrintWindowMagnification;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  { Update the query component. Please make sure that  }
  { you have entered a valid Query to Memo1 component. }
  Query1.Active := FALSE;
  Query1.SQL.Assign(Memo1.Lines);
  Query1.Active := TRUE;

  { Re-activate the report }
  ActivateComponent;
end;

end.
